#! /usr/bin/perl

use lib './';
use Zip;
use Encode;
use Encode::Guess;
use Unicode::Normalize;

$|++;
my $zipfile = shift or die "no zip file?\n";
die "no zip file\n" unless -f $zipfile;

my $zip = Archive::Zip->new($zipfile);
my @members = $zip->members();
my $dirty = 0;

foreach my $member (@members) {
    my $mbsjis = my $mbutf8 = $member->fileName();
    my $enc = guess_encoding($mbutf8, qw/shiftjis utf8/);
    if (! ref($enc)) {
#	print "Can't guess: $enc\n"; #　自動判定に失敗したときのエラー処理
        # may be utf8
#	print "UTF8-0:",$mbutf8,"\n";
    } else {
#	print "Enc=",$enc->name,"   ";
	if($enc->name eq "utf8") {
#	    print "UTF8-1:",$mbutf8,"\n";
	} else {
	    Encode::from_to($mbutf8, 'Shift_JIS', 'UTF-8');
	    $member->fileName($mbutf8);
	    $dirty = 1;
#	    print "UTF8-2:",$mbutf8,"\n";
	}
    }
#    print "UTF8:",$member->fileName,"\n";
}
$zip->overwrite() if ($dirty);

#end
