#! /usr/bin/perl
use lib './';
use Zip;
use Encode;
use Unicode::Normalize;

my $zipfile = shift or die "no zip file?\n";
die "no zip file\n" unless -f $zipfile;

my $zip = Archive::Zip->new($zipfile);
my @members = $zip->members();
my $dirty = 0;

foreach my $member (@members) {
    my $mbsjis = my $mbutf8 = $member->fileName();
    if ($mbutf8 =~ /^__MACOSX\//) {
		$zip->removeMember($member);
		$dirty = 1;
		next;
    }
    if ($mbutf8 =~ /\/\.DS_Store/) {
		$zip->removeMember($member);
		$dirty = 1;
		next;
    }

    $mbsjis = Encode::encode('Shift_JIS', NFC(Encode::decode_utf8($mbutf8)), Encode::FB_XMLCREF);
    $member->fileName($mbsjis);
	$dirty = 1;
#	print $mbutf8,"\n";
}

$zip->overwrite() if ($dirty);

#end
